MySQL/MariaDB/Percona数据库升级脚本

2019-06-15 作者:计算机教程   |   浏览(146)

感谢阅读,希望能帮助到大家,谢谢大家对本站的支持!

MySQL/MariaDB/Percona数据库升级脚本,mariadbpercona

MySQL/MariaDB/Percona数据库升级脚本截取《OneinStack》中upgrade_db.sh, 一般情况下不建议升级数据库版本,该脚本专提供给各位版本控们。为防止大版本之间兼容问题,脚本默认仅支持同一大版本之间的升级,如:MySQL- 5.6.25升级到MySQL-5.6.26、MySQL-5.5.44升级到MySQL-5.5.45、MariaDB-10.0.20升级到 MariaDB-10.0.21;不能跨分支版本且不能跨大版本,如从MySQL-5.5.44升级到PerconaL-5.5.44-37.3、 MySQL-5.5.44升级到MySQL-5.6.25。

2015-07-16之前版本如何支持数据库版本升级?
《OneinStack》*永利电子游戏网站,*:**

cp oneinstack/options.conf ./  #备份options.conf
rm -rf oneinstack  #删除旧版
wget http://mirrors.linuxeye.com/oneinstack-full.tar.gz  #下载最新版
tar xzf oneinstack-full.tar.gz
/bin/mv options.conf ./oneinstack  #还原options.conf, 必须使用旧版options.conf文件
cd oneinstack
./upgrade db  #升级数据库版本

《lnmp一键安装包》:

cp lnmp/options.conf ./  #备份options.conf
rm -rf lnmp  #删除旧版
wget http://mirrors.linuxeye.com/lnmp-full.tar.gz  #下载最新版
tar xzf lnmp-full.tar.gz
/bin/mv options.conf ./lnmp  #还原options.conf, 必须使用旧版options.conf文件
cd lnmp
./upgrade db  #升级数据库版本

PS:
MySQL/MariaDB/Percona数据库升级脚本内容如下(cat upgrade_db.sh):

#!/bin/bash
# Author:  yeho <lj2007331 AT gmail.com>
# Blog:  http://blog.linuxeye.com

Upgrade_DB()
{
cd $oneinstack_dir/src
[ ! -e "$db_install_dir/bin/mysql" ] && echo -e "33[31mThe MySQL/MariaDB/Percona is not installed on your system!33[0m " && exit 1
DB_version_tmp=`$db_install_dir/bin/mysql -V | awk '{print $5}' | awk -F, '{print $1}'`
DB_tmp=`echo $DB_version_tmp | awk -F'-' '{print $2}'`
if [ "$DB_tmp" == 'MariaDB' ];then
 public_IP=`../functions/get_public_ip.py`
 if [ "`../functions/get_ip_area.py $public_IP`" == 'u4e2du56fd' ];then
         FLAG_IP=CN
 fi
 [ "$FLAG_IP"x == "CN"x ] && DOWN_ADDR=http://mirrors.aliyun.com/mariadb || DOWN_ADDR=https://downloads.mariadb.org/f
 [ -d "/lib64" ] && { SYS_BIT_a=x86_64;SYS_BIT_b=x86_64; } || { SYS_BIT_a=x86;SYS_BIT_b=i686; }
 LIBC_VERSION=`getconf -a | grep GNU_LIBC_VERSION | awk '{print $NF}'`
 LIBC_YN=`echo "$LIBC_VERSION < 2.14" | bc`
 [ $LIBC_YN == '1' ] && GLIBC_FLAG=linux || GLIBC_FLAG=linux-glibc_214

 DB=MariaDB
 Old_DB_version=`echo $DB_version_tmp | awk -F'-' '{print $1}'`
elif [ -n "$DB_tmp" -a "$DB_tmp" != 'MariaDB' ];then
 DB=Percona
 Old_DB_version=$DB_version_tmp
else
 DB=MySQL
 Old_DB_version=$DB_version_tmp
fi

#backup
while :
do
        $db_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "quit" >/dev/null 2>&1
        if [ $? -eq 0 ];then
                break
        else
                echo
                read -p "Please input the root password of database: " NEW_dbrootpwd
                $db_install_dir/bin/mysql -uroot -p${NEW_dbrootpwd} -e "quit" >/dev/null 2>&1
                if [ $? -eq 0 ];then
                        dbrootpwd=$NEW_dbrootpwd
                        sed -i "s ^dbrootpwd.* dbrootpwd='$dbrootpwd' " ../options.conf
                        break
                else
                        echo -e "33[31m$DB root password incorrect,Please enter again! 33[0m"
                fi
        fi

done
echo
echo -e "33[32mStarting $DB backup......33[0m"
$db_install_dir/bin/mysqldump -uroot -p${dbrootpwd} --opt --all-databases > DB_all_backup_$(date  "%Y%m%d").sql
[ -f "DB_all_backup_$(date  "%Y%m%d").sql" ] && echo -e "$DB backup success, Backup file: 33[32m`pwd`/DB_all_backup_$(date  "%Y%m%d").sql33[0m"

#upgrade
echo
echo -e "Current $DB Version: 33[32m$Old_DB_version33[0m"
[ -e /usr/local/lib/libtcmalloc.so ] && { je_tc_malloc=2; EXE_LINKER="-DCMAKE_EXE_LINKER_FLAGS='-ltcmalloc'"; }
[ -e /usr/local/lib/libjemalloc.so ] && { je_tc_malloc=1; EXE_LINKER="-DCMAKE_EXE_LINKER_FLAGS='-ljemalloc'"; }

while :
do
        echo
        read -p "Please input upgrade $DB Version(example: 5.6.25): " DB_version
        if [ `echo $DB_version | awk -F. '{print $1"."$2}'` == `echo $Old_DB_version | awk -F. '{print $1"."$2}'` ]; then
  if [ "$DB" == 'MariaDB' ];then
   DB_name=mariadb-${DB_version}-${GLIBC_FLAG}-${SYS_BIT_b}
   DB_URL=$DOWN_ADDR/mariadb-${DB_version}/bintar-${GLIBC_FLAG}-$SYS_BIT_a/$DB_name.tar.gz
  elif [ "$DB" == 'Percona' ];then
   DB_name=percona-server-$DB_version
   DB_URL=http://www.percona.com/redir/downloads/Percona-Server-`echo $DB_version | awk -F. '{print $1"."$2}'`/LATEST/source/tarball/$DB_name.tar.gz
  elif [ "$DB" == 'MySQL' ];then
   DB_name=mysql-$DB_version
   DB_URL=http://cdn.mysql.com/Downloads/MySQL-`echo $DB_version | awk -F. '{print $1"."$2}'`/$DB_name.tar.gz
  fi
                [ ! -e "$DB_name.tar.gz" ] && wget -c $DB_URL > /dev/null 2>&1

                if [ -e "$DB_name.tar.gz" ];then
                        echo -e "Download 33[32m$DB_name.tar.gz33[0m successfully! "
                else
                        echo -e "33[31mIt does not exist!33[0m"
                fi
                break
        else
                echo -e "33[31minput error!33[0m Please only input '33[32m${Old_DB_version%.*}.xx' 33[0m"
        fi
done

if [ -e "$DB_name.tar.gz" ];then
        echo -e "33[32m$DB_name.tar.gz33[0m [found]"
        echo "Press Ctrl c to cancel or Press any key to continue..."
        char=`get_char`
 if [ "$DB" == 'MariaDB' ];then 
  service mysqld stop
  mv ${db_install_dir}{,_old_`date  "%Y%m%d"`}
  mv ${db_data_dir}{,_old_`date  "%Y%m%d"`}
  mkdir -p $db_data_dir;chown mysql.mysql -R $db_data_dir
  tar xzf $DB_name.tar.gz
  [ ! -d "$db_install_dir" ] && mkdir -p $db_install_dir
  mv mariadb-${DB_version}-linux-${SYS_BIT_b}/* $db_install_dir
  if [ "$je_tc_malloc" == '1' ];then
          sed -i '[email protected] [email protected] mysqld_safenexport LD_PRELOAD=/usr/local/lib/[email protected]' $db_install_dir/bin/mysqld_safe
  elif [ "$je_tc_malloc" == '2' ];then
          sed -i '[email protected] [email protected] mysqld_safenexport LD_PRELOAD=/usr/local/lib/[email protected]' $db_install_dir/bin/mysqld_safe
  fi
  $db_install_dir/scripts/mysql_install_db --user=mysql --basedir=$db_install_dir --datadir=$db_data_dir
  chown mysql.mysql -R $db_data_dir
  service mysqld start
  $db_install_dir/bin/mysql < DB_all_backup_$(date  "%Y%m%d").sql 
  service mysqld restart
  $db_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "drop database test;" >/dev/null 2>&1
  $db_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "reset master;" >/dev/null 2>&1
                [ $? -eq 0 ] &&  echo -e "You have 33[32m$DB successfully33[0m upgrade from 33[32m$Old_DB_version33[0m to 33[32m$DB_version33[0m"
 elif [ "$DB" == 'Percona' ];then
  tar zxf $DB_name.tar.gz 
  cd $DB_name
  make clean
  if [ "`echo $DB_version | awk -F. '{print $1"."$2}'`" == '5.5' ];then
   cmake . -DCMAKE_INSTALL_PREFIX=$db_install_dir 
-DMYSQL_DATADIR=$db_data_dir 
-DSYSCONFDIR=/etc 
-DWITH_INNOBASE_STORAGE_ENGINE=1 
-DWITH_PARTITION_STORAGE_ENGINE=1 
-DWITH_FEDERATED_STORAGE_ENGINE=1 
-DWITH_BLACKHOLE_STORAGE_ENGINE=1 
-DWITH_MYISAM_STORAGE_ENGINE=1 
-DWITH_ARCHIVE_STORAGE_ENGINE=1 
-DWITH_READLINE=1 
-DENABLE_DTRACE=0 
-DENABLED_LOCAL_INFILE=1 
-DDEFAULT_CHARSET=utf8mb4 
-DDEFAULT_COLLATION=utf8mb4_general_ci 
$EXE_LINKER
  else
   cmake . -DCMAKE_INSTALL_PREFIX=$db_install_dir 
-DMYSQL_DATADIR=$db_data_dir 
-DSYSCONFDIR=/etc 
-DWITH_INNOBASE_STORAGE_ENGINE=1 
-DWITH_PARTITION_STORAGE_ENGINE=1 
-DWITH_FEDERATED_STORAGE_ENGINE=1 
-DWITH_BLACKHOLE_STORAGE_ENGINE=1 
-DWITH_MYISAM_STORAGE_ENGINE=1 
-DWITH_ARCHIVE_STORAGE_ENGINE=1 
-DENABLED_LOCAL_INFILE=1 
-DENABLE_DTRACE=0 
-DDEFAULT_CHARSET=utf8mb4 
-DDEFAULT_COLLATION=utf8mb4_general_ci 
$EXE_LINKER
  fi
  make -j `grep processor /proc/cpuinfo | wc -l`
  service mysqld stop
  mv ${db_install_dir}{,_old_`date  "%Y%m%d"`}
                mv ${db_data_dir}{,_old_`date  "%Y%m%d"`}
  [ ! -d "$db_install_dir" ] && mkdir -p $db_install_dir
                mkdir -p $db_data_dir;chown mysql.mysql -R $db_data_dir
  make install
  $db_install_dir/scripts/mysql_install_db --user=mysql --basedir=$db_install_dir --datadir=$db_data_dir
                chown mysql.mysql -R $db_data_dir
                service mysqld start
  $db_install_dir/bin/mysql < DB_all_backup_$(date  "%Y%m%d").sql
                service mysqld restart
  $db_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "drop database test;" >/dev/null 2>&1
  $db_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "reset master;" >/dev/null 2>&1
                [ $? -eq 0 ] &&  echo -e "You have 33[32m$DB successfully33[0m upgrade from 33[32m$Old_DB_version33[0m to 33[32m$DB_version33[0m"
 elif [ "$DB" == 'MySQL' ];then
  tar zxf $DB_name.tar.gz
                cd $DB_name
                make clean
                if [ "`echo $DB_version | awk -F. '{print $1"."$2}'`" == '5.5' ];then
                        cmake . -DCMAKE_INSTALL_PREFIX=$db_install_dir 
-DMYSQL_DATADIR=$db_data_dir 
-DSYSCONFDIR=/etc 
-DWITH_INNOBASE_STORAGE_ENGINE=1 
-DWITH_PARTITION_STORAGE_ENGINE=1 
-DWITH_FEDERATED_STORAGE_ENGINE=1 
-DWITH_BLACKHOLE_STORAGE_ENGINE=1 
-DWITH_MYISAM_STORAGE_ENGINE=1 
-DWITH_ARCHIVE_STORAGE_ENGINE=1 
-DWITH_READLINE=1 
-DENABLED_LOCAL_INFILE=1 
-DENABLE_DTRACE=0 
-DDEFAULT_CHARSET=utf8mb4 
-DDEFAULT_COLLATION=utf8mb4_general_ci 
-DWITH_EMBEDDED_SERVER=1 
$EXE_LINKER
                else
                        cmake . -DCMAKE_INSTALL_PREFIX=$db_install_dir 
-DMYSQL_DATADIR=$db_data_dir 
-DSYSCONFDIR=/etc 
-DWITH_INNOBASE_STORAGE_ENGINE=1 
-DWITH_PARTITION_STORAGE_ENGINE=1 
-DWITH_FEDERATED_STORAGE_ENGINE=1 
-DWITH_BLACKHOLE_STORAGE_ENGINE=1 
-DWITH_MYISAM_STORAGE_ENGINE=1 
-DENABLED_LOCAL_INFILE=1 
-DENABLE_DTRACE=0 
-DDEFAULT_CHARSET=utf8mb4 
-DDEFAULT_COLLATION=utf8mb4_general_ci 
-DWITH_EMBEDDED_SERVER=1 
$EXE_LINKER
                fi
  make -j `grep processor /proc/cpuinfo | wc -l`
  service mysqld stop
                mv ${db_install_dir}{,_old_`date  "%Y%m%d"`}
                mv ${db_data_dir}{,_old_`date  "%Y%m%d"`}
                [ ! -d "$db_install_dir" ] && mkdir -p $db_install_dir
                mkdir -p $db_data_dir;chown mysql.mysql -R $db_data_dir
                make install
  $db_install_dir/scripts/mysql_install_db --user=mysql --basedir=$db_install_dir --datadir=$db_data_dir
                chown mysql.mysql -R $db_data_dir
                service mysqld start
                $db_install_dir/bin/mysql < DB_all_backup_$(date  "%Y%m%d").sql
                service mysqld restart
  $db_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "drop database test;" >/dev/null 2>&1
  $db_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "reset master;" >/dev/null 2>&1
                [ $? -eq 0 ] &&  echo -e "You have 33[32m$DB successfully33[0m upgrade from 33[32m$Old_DB_version33[0m to 33[32m$DB_version33[0m"
 fi 
fi
}

原文:https://blog.linuxeye.com/424.html

http://www.bkjia.com/Mysql/1032536.htmlwww.bkjia.comtruehttp://www.bkjia.com/Mysql/1032536.htmlTechArticleMySQL/MariaDB/Percona数据库升级脚本,mariadbpercona MySQL/ MariaDB/ Percona数据库升级脚本截取《OneinStack》中upgrade_db.sh, 一般情况下不建议升级数据...

MySQL/MariaDB/Percona数据库升级脚本

#!/bin/bash 
# Author: yeho <lj2007331 AT gmail.com> 
# BLOG: https://blog.linuxeye.com 
# 
# Notes: OneinStack for CentOS/RadHat 5  Debian 6  and Ubuntu 12  
# 
# Project home page: 
#    http://oneinstack.com 
#    https://github.com/lj2007331/oneinstack 

Upgrade_DB() 
{ 
cd $oneinstack_dir/src 
[ ! -e "$db_install_dir/bin/mysql" ] && echo "${CWARNING}The MySQL/MariaDB/Percona is not installed on your system! ${CEND}" && exit 1 
OLD_DB_version_tmp=`$db_install_dir/bin/mysql -V | awk '{print $5}' | awk -F, '{print $1}'` 
DB_tmp=`echo $OLD_DB_version_tmp | awk -F'-' '{print $2}'` 
if [ "$DB_tmp" == 'MariaDB' ];then 
  [ "$IPADDR_STATE"x == "CN"x ] && DOWN_ADDR=http://mirrors.aliyun.com/mariadb || DOWN_ADDR=https://downloads.mariadb.org/f 
  LIBC_VERSION=`getconf -a | grep GNU_LIBC_VERSION | awk '{print $NF}'` 
  LIBC_YN=`echo "$LIBC_VERSION < 2.14" | bc` 
  [ $LIBC_YN == '1' ] && GLIBC_FLAG=linux || GLIBC_FLAG=linux-glibc_214 
  DB=MariaDB 
  OLD_DB_version=`echo $OLD_DB_version_tmp | awk -F'-' '{print $1}'` 
elif [ -n "$DB_tmp" -a "$DB_tmp" != 'MariaDB' ];then 
  DB=Percona 
  OLD_DB_version=$OLD_DB_version_tmp 
else 
  DB=MySQL 
  OLD_DB_version=$OLD_DB_version_tmp 
fi 

#backup 
while : 
do 
  $db_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "quit" >/dev/null 2>&1 
  if [ $? -eq 0 ];then 
    break 
  else 
    echo 
    read -p "Please input the root password of database: " NEW_dbrootpwd 
    $db_install_dir/bin/mysql -uroot -p${NEW_dbrootpwd} -e "quit" >/dev/null 2>&1 
    if [ $? -eq 0 ];then 
      dbrootpwd=$NEW_dbrootpwd 
      sed -i "s ^dbrootpwd.* dbrootpwd='$dbrootpwd' " ../options.conf 
      break 
    else 
      echo "${CFAILURE}$DB root password incorrect,Please enter again! ${CEND}" 
    fi 
  fi 
done 

echo 
echo "${CSUCCESS}Starting $DB backup${CEND}......" 
$db_install_dir/bin/mysqldump -uroot -p${dbrootpwd} --opt --all-databases > DB_all_backup_$(date  "%Y%m%d").sql 
[ -f "DB_all_backup_$(date  "%Y%m%d").sql" ] && echo "$DB backup success, Backup file: ${MSG}`pwd`/DB_all_backup_$(date  "%Y%m%d").sql${CEND}" 

#upgrade 
echo 
echo "Current $DB Version: ${CMSG}$OLD_DB_version${CEND}" 
[ -e /usr/local/lib/libtcmalloc.so ] && { je_tc_malloc=2; EXE_LINKER="-DCMAKE_EXE_LINKER_FLAGS='-ltcmalloc'"; } 
[ -e /usr/local/lib/libjemalloc.so ] && { je_tc_malloc=1; EXE_LINKER="-DCMAKE_EXE_LINKER_FLAGS='-ljemalloc'"; } 

while : 
do 
  echo 
  read -p "Please input upgrade $DB Version(example: $OLD_DB_version): " NEW_DB_version 
  if [ `echo $NEW_DB_version | awk -F. '{print $1"."$2}'` == `echo $OLD_DB_version | awk -F. '{print $1"."$2}'` ]; then 
    if [ "$DB" == 'MariaDB' ];then 
      DB_name=mariadb-${NEW_DB_version}-${GLIBC_FLAG}-${SYS_BIT_b} 
      DB_URL=$DOWN_ADDR/mariadb-${NEW_DB_version}/bintar-${GLIBC_FLAG}-$SYS_BIT_a/$DB_name.tar.gz 
    elif [ "$DB" == 'Percona' ];then 
      DB_name=percona-server-$NEW_DB_version 
      DB_URL=http://www.percona.com/redir/downloads/Percona-Server-`echo $NEW_DB_version | awk -F. '{print $1"."$2}'`/LATEST/source/tarball/$DB_name.tar.gz 
    elif [ "$DB" == 'MySQL' ];then 
      DB_name=mysql-$NEW_DB_version 
      DB_URL=http://cdn.mysql.com/Downloads/MySQL-`echo $NEW_DB_version | awk -F. '{print $1"."$2}'`/$DB_name.tar.gz 
    fi 
      [ ! -e "$DB_name.tar.gz" ] && wget --no-check-certificate -c $DB_URL > /dev/null 2>&1 

      if [ -e "$DB_name.tar.gz" ];then 
        echo "Download [${CMSG}$DB_name.tar.gz${CEND}] successfully! " 
      else 
        echo "${CWARNING}$DB version does not exist! ${CEND}" 
      fi 
      break 
  else 
      echo "${CWARNING}input error! ${CEND}Please only input '${CMSG}${OLD_DB_version%.*}.xx${CEND}'" 
  fi 
done 

if [ -e "$DB_name.tar.gz" ];then 
  echo "[${CMSG}$DB_name.tar.gz${CEND}] found" 
  echo "Press Ctrl c to cancel or Press any key to continue..." 
  char=`get_char` 
  if [ "$DB" == 'MariaDB' ];then  
    service mysqld stop 
    mv ${mariadb_install_dir}{,_old_`date  "%Y%m%d"`} 
    mv ${mariadb_data_dir}{,_old_`date  "%Y%m%d"`} 
    mkdir -p $mariadb_data_dir;chown mysql.mysql -R $mariadb_data_dir 
    tar xzf $DB_name.tar.gz 
    [ ! -d "$mariadb_install_dir" ] && mkdir -p $mariadb_install_dir 
    mv mariadb-${NEW_DB_version}-*-${SYS_BIT_b}/* $mariadb_install_dir 
    if [ "$je_tc_malloc" == '1' -a "`echo $OLD_DB_version_tmp | awk -F'.' '{print $1"."$2}'`" != '10.1' ];then 
      sed -i 's@executing mysqld_safe@executing mysqld_safenexport LD_PRELOAD=/usr/local/lib/libjemalloc.so@' $mariadb_install_dir/bin/mysqld_safe 
    elif [ "$je_tc_malloc" == '2' -a "`echo $OLD_DB_version_tmp | awk -F'.' '{print $1"."$2}'`" != '10.1' ];then 
      sed -i 's@executing mysqld_safe@executing mysqld_safenexport LD_PRELOAD=/usr/local/lib/libtcmalloc.so@' $mariadb_install_dir/bin/mysqld_safe 
    fi 
    $mariadb_install_dir/scripts/mysql_install_db --user=mysql --basedir=$mariadb_install_dir --datadir=$mariadb_data_dir 
    chown mysql.mysql -R $mariadb_data_dir 
    service mysqld start 
    $mariadb_install_dir/bin/mysql < DB_all_backup_$(date  "%Y%m%d").sql  
    service mysqld restart 
    $mariadb_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "drop database test;" >/dev/null 2>&1 
    $mariadb_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "reset master;" >/dev/null 2>&1 
    [ $? -eq 0 ] && echo "You have ${CMSG}successfully${CEND} upgrade from ${CMSG}$OLD_DB_version${CEND} to ${CMSG}$NEW_DB_version${CEND}" 
  elif [ "$DB" == 'Percona' ];then 
    tar zxf $DB_name.tar.gz  
    cd $DB_name 
    make clean 
    if [ "`echo $NEW_DB_version | awk -F. '{print $1"."$2}'`" == '5.5' ];then 
      cmake . -DCMAKE_INSTALL_PREFIX=$percona_install_dir  
-DMYSQL_DATADIR=$percona_data_dir  
-DSYSCONFDIR=/etc  
-DWITH_INNOBASE_STORAGE_ENGINE=1  
-DWITH_PARTITION_STORAGE_ENGINE=1  
-DWITH_FEDERATED_STORAGE_ENGINE=1  
-DWITH_BLACKHOLE_STORAGE_ENGINE=1  
-DWITH_MYISAM_STORAGE_ENGINE=1  
-DWITH_ARCHIVE_STORAGE_ENGINE=1  
-DWITH_READLINE=1  
-DENABLE_DTRACE=0  
-DENABLED_LOCAL_INFILE=1  
-DDEFAULT_CHARSET=utf8mb4  
-DDEFAULT_COLLATION=utf8mb4_general_ci  
$EXE_LINKER 
    else 
      cmake . -DCMAKE_INSTALL_PREFIX=$percona_install_dir  
-DMYSQL_DATADIR=$percona_data_dir  
-DSYSCONFDIR=/etc  
-DWITH_INNOBASE_STORAGE_ENGINE=1  
-DWITH_PARTITION_STORAGE_ENGINE=1  
-DWITH_FEDERATED_STORAGE_ENGINE=1  
-DWITH_BLACKHOLE_STORAGE_ENGINE=1  
-DWITH_MYISAM_STORAGE_ENGINE=1  
-DWITH_ARCHIVE_STORAGE_ENGINE=1  
-DENABLED_LOCAL_INFILE=1  
-DENABLE_DTRACE=0  
-DDEFAULT_CHARSET=utf8mb4  
-DDEFAULT_COLLATION=utf8mb4_general_ci  
$EXE_LINKER 
    fi 
    make -j `grep processor /proc/cpuinfo | wc -l` 
    service mysqld stop 
    mv ${percona_install_dir}{,_old_`date  "%Y%m%d"`} 
    mv ${percona_data_dir}{,_old_`date  "%Y%m%d"`} 
    [ ! -d "$percona_install_dir" ] && mkdir -p $percona_install_dir 
    mkdir -p $percona_data_dir;chown mysql.mysql -R $percona_data_dir 
    make install 
    cd .. 
    $percona_install_dir/scripts/mysql_install_db --user=mysql --basedir=$percona_install_dir --datadir=$percona_data_dir 
    chown mysql.mysql -R $percona_data_dir 
    service mysqld start 
    $percona_install_dir/bin/mysql < DB_all_backup_$(date  "%Y%m%d").sql 
    service mysqld restart 
    $percona_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "drop database test;" >/dev/null 2>&1 
    $percona_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "reset master;" >/dev/null 2>&1 
    [ $? -eq 0 ] && echo "You have ${CMSG}successfully${CEND} upgrade from ${CMSG}$OLD_DB_version${CEND} to ${CMSG}$NEW_DB_version${CEND}" 
  elif [ "$DB" == 'MySQL' ];then 
    tar zxf $DB_name.tar.gz 
    cd $DB_name 
    make clean 
    if [ "`echo $NEW_DB_version | awk -F. '{print $1"."$2}'`" == '5.5' ];then 
      cmake . -DCMAKE_INSTALL_PREFIX=$mysql_install_dir  
-DMYSQL_DATADIR=$mysql_data_dir  
-DSYSCONFDIR=/etc  
-DWITH_INNOBASE_STORAGE_ENGINE=1  
-DWITH_PARTITION_STORAGE_ENGINE=1  
-DWITH_FEDERATED_STORAGE_ENGINE=1  
-DWITH_BLACKHOLE_STORAGE_ENGINE=1  
-DWITH_MYISAM_STORAGE_ENGINE=1  
-DWITH_ARCHIVE_STORAGE_ENGINE=1  
-DWITH_READLINE=1  
-DENABLED_LOCAL_INFILE=1  
-DENABLE_DTRACE=0  
-DDEFAULT_CHARSET=utf8mb4  
-DDEFAULT_COLLATION=utf8mb4_general_ci  
-DWITH_EMBEDDED_SERVER=1  
$EXE_LINKER 
    else 
      cmake . -DCMAKE_INSTALL_PREFIX=$mysql_install_dir  
-DMYSQL_DATADIR=$mysql_data_dir  
-DSYSCONFDIR=/etc  
-DWITH_INNOBASE_STORAGE_ENGINE=1  
-DWITH_PARTITION_STORAGE_ENGINE=1  
-DWITH_FEDERATED_STORAGE_ENGINE=1  
-DWITH_BLACKHOLE_STORAGE_ENGINE=1  
-DWITH_MYISAM_STORAGE_ENGINE=1  
-DENABLED_LOCAL_INFILE=1  
-DENABLE_DTRACE=0  
-DDEFAULT_CHARSET=utf8mb4  
-DDEFAULT_COLLATION=utf8mb4_general_ci  
-DWITH_EMBEDDED_SERVER=1  
$EXE_LINKER 
    fi 
    make -j `grep processor /proc/cpuinfo | wc -l` 
    service mysqld stop 
    mv ${mysql_install_dir}{,_old_`date  "%Y%m%d"`} 
    mv ${mysql_data_dir}{,_old_`date  "%Y%m%d"`} 
    [ ! -d "$mysql_install_dir" ] && mkdir -p $mysql_install_dir 
    mkdir -p $mysql_data_dir;chown mysql.mysql -R $mysql_data_dir 
    make install 
    cd .. 
    $mysql_install_dir/scripts/mysql_install_db --user=mysql --basedir=$mysql_install_dir --datadir=$mysql_data_dir 
    chown mysql.mysql -R $mysql_data_dir 
    service mysqld start 
    $mysql_install_dir/bin/mysql < DB_all_backup_$(date  "%Y%m%d").sql 
    service mysqld restart 
    $mysql_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "drop database test;" >/dev/null 2>&1 
    $mysql_install_dir/bin/mysql -uroot -p${dbrootpwd} -e "reset master;" >/dev/null 2>&1 
    [ $? -eq 0 ] && echo "You have ${CMSG}successfully${CEND} upgrade from ${CMSG}$OLD_DB_version${CEND} to ${CMSG}$NEW_DB_version${CEND}" 
  fi  
fi 
} 

MySQL/MariaDB/Percona数据库升级脚本截取《OneinStack》中upgrade_db.sh,一般情况下不建议升级数据库版本,该脚本专提供给各位版本控们。为防止大版本之间兼容问题,脚本默认仅支持同一大版本之间的升级,如:MySQL-5.6.25升级到MySQL-5.6.26、MySQL-5.5.44升级到MySQL-5.5.45、MariaDB-10.0.20升级到MariaDB-10.0.21;不能跨分支版本且不能跨大版本,如从MySQL-5.5.44升级到PerconaL-5.5.44-37.3、MySQL-5.5.44升级到MySQL-5.6.25。

《OneinStack》:

cp lnmp/options.conf ~ #备份options.conf
rm -rf lnmp #删除旧版
wget http://mirrors.linuxeye.com/lnmp-full.tar.gz #下载最新版
tar xzf lnmp-full.tar.gz
/bin/mv ~/options.conf ./lnmp #还原options.conf, 必须使用旧版options.conf文件
cd lnmp
./upgrade db #升级数据库版本

本文由永利电子游戏网站发布于计算机教程,转载请注明出处:MySQL/MariaDB/Percona数据库升级脚本

关键词: